# -*- coding: utf-8 -*-

"""
postnl

This file was automatically generated for PostNL by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from postnl.api_helper import APIHelper
from postnl.models.delivery_option import DeliveryOption
from postnl.models.pickup_option import PickupOption
from postnl.models.warning import Warning


class CheckoutResponse(object):

    """Implementation of the 'checkoutResponse' model.

    TODO: type model description here.

    Attributes:
        delivery_options (List[DeliveryOption]): Array of delivery options
        pickup_options (List[PickupOption]): Array of possible pickup options
        warnings (List[Warning]): An array of warnings

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "delivery_options": 'DeliveryOptions',
        "pickup_options": 'PickupOptions',
        "warnings": 'Warnings'
    }

    _optionals = [
        'delivery_options',
        'pickup_options',
        'warnings',
    ]

    def __init__(self,
                 delivery_options=APIHelper.SKIP,
                 pickup_options=APIHelper.SKIP,
                 warnings=APIHelper.SKIP):
        """Constructor for the CheckoutResponse class"""

        # Initialize members of the class
        if delivery_options is not APIHelper.SKIP:
            self.delivery_options = delivery_options 
        if pickup_options is not APIHelper.SKIP:
            self.pickup_options = pickup_options 
        if warnings is not APIHelper.SKIP:
            self.warnings = warnings 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        delivery_options = None
        if dictionary.get('DeliveryOptions') is not None:
            delivery_options = [DeliveryOption.from_dictionary(x) for x in dictionary.get('DeliveryOptions')]
        else:
            delivery_options = APIHelper.SKIP
        pickup_options = None
        if dictionary.get('PickupOptions') is not None:
            pickup_options = [PickupOption.from_dictionary(x) for x in dictionary.get('PickupOptions')]
        else:
            pickup_options = APIHelper.SKIP
        warnings = None
        if dictionary.get('Warnings') is not None:
            warnings = [Warning.from_dictionary(x) for x in dictionary.get('Warnings')]
        else:
            warnings = APIHelper.SKIP
        # Return an object of this model
        return cls(delivery_options,
                   pickup_options,
                   warnings)
